unit FoAblak;{Megolds}
(*
  Feladat:
    Az albbi szerkezet file beolvassa s kilistzsa
    1. lapozottan "jzansszel",
    2. gy, hogy a tpusfinomtssal komolyabban lnk
       (azaz ne hasznljuk ki, hogy az ElemKi figyeli a kirt sorok szmt),
    3. az egy tanszken dolgozk kifrjenek egy lapra
       (a tanszk nyitrekorddal egytt)
       Ef: nincs tanszk, ahol tbben dolgoznnak, mint a kpernysorok
           szma-2 ("-2" = fejsor + sorszmot tartalmaz lblc)
    4. minden szervezeti egysget egy n. sszegz rekorddal kiegsztve, s
       fenntartva az egyttmarads felttelt.
       Ef: olyan, hogy megvalsthat legyen...

  File-szerkezet:

    1. szint: EGYETEM
      szintkd, nv, rektori hivatal cm, tel.szm
      karok

    2. szint: KAR
      szintkd, nv, dkni hivatal cm, tel.szm
      tanszkek (tanszki egysgek)

    3. szint: TANSZKEK
      szintkd, nv, tanszkcm, tel.szm
      dolgozk

    4. szint: DOLGOZ
      szintkd, nv, lakcm, tel.szm, fizets, ...

    Felttelezs:
      A file strukturlisan helyes, nem res.

    Megjegyzsek:
      A file csupa azonos tpus elembl ll. Ezrt a struktranyit elemek
      kiegszlnek --"tartalom nlkli"-- mezkkel,  amelyeket esetleg fl
      lehet hasznlni az sszegfokozatok utlagos trolsra.
      A mellkelt prbafjlok (elteX.dat nevben az X utal arra, hogy
      generlskor mekkora volt a lapHossz paramter; ennl nem kisebb lapHossz
      mellett szabad csak felhasznni).FoAblak
*)

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Menus,
  ComCtrls, StdCtrls, ExtCtrls;

type

  { TfmFoAblak }

  TfmFoAblak = class(TForm)
    miSorokSzama: TMenuItem;
    mmOutput: TMemo;
    miTanszekenkent: TMenuItem;
    miGeneral: TMenuItem;
    miMaskent: TMenuItem;
    miOsszegfok: TMenuItem;
    miKilep: TMenuItem;
    mmAlapMenu: TMenuItem;
    mmMuvelet: TMenuItem;
    miMegnyit: TMenuItem;
    miSima: TMenuItem;
    mmFoMenu: TMainMenu;
    odBe: TOpenDialog;
    sdKi: TSaveDialog;
    sbAllapotok: TStatusBar;
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure miOsszegfokClick(Sender: TObject);
    procedure miSorokSzamaClick(Sender: TObject);
    procedure miTanszekenkentClick(Sender: TObject);
    procedure miGeneralClick(Sender: TObject);
    procedure miKilepClick(Sender: TObject);
    procedure miMaskentClick(Sender: TObject);
    procedure miMegnyitClick(Sender: TObject);
    procedure miSimaClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  fmFoAblak: TfmFoAblak;
  fN:string;//a hasznlatban lv fjl neve

implementation

{ TfmFoAblak }

uses
  listazas, GeneralParameterAblak;

procedure TfmFoAblak.miGeneralClick(Sender: TObject);
  var
    letezik,megsem:boolean;
    f:TFile;
begin
  //Generls:
  megsem:=false; letezik:=true;
  while not megsem and letezik do
  begin
    megsem:=not sdKi.Execute;
    if not megsem then
    begin
      fN:=sdKi.FileName;
      assignFile(f,fN);
      {$i-}reset(f);{$i+}
      letezik:=IOResult=0;
      if letezik then
      begin
        letezik:=MessageDlg('Ez a fjl mr ltezik! J lesz?',
                            mtConfirmation,[mbYes,mbNo],0)=mrNo;
      end;//if IOResult
      closeFile(f);
    end;//if not megsem
  end;//while not megsem
  if not megsem and not letezik then
  begin
    general(fN);
    mmMuvelet.Enabled:=true;
    mmOutput.Clear;
    sbAllapotok.Panels.Items[5].Text:=fN;
    sbAllapotok.Panels.Items[7].Text:=intToStr(maxTanszekMeret(fN));
  end
    else
  begin
    mmMuvelet.Enabled:=false;
  end;//if
end;//TfmFoAblak.miGeneralClick

procedure TfmFoAblak.miMegnyitClick(Sender: TObject);
  var
    lh:integer;
begin
  if odBe.Execute then
  begin
    fN:=odBe.FileName;
    mmMuvelet.Enabled:=true;
    mmOutput.Clear;
    sbAllapotok.Panels.Items[5].Text:=fN;
    //MaxTanszkMret(fN)+(minLapHossz-MinTanszLetsz)<=LapHossz
    //felttel ellenrzse:
    lh:=MaxTanszekMeret(fN)+(minLapHossz-MinTanszLetsz);
    if lh>LapHossz then
    begin
      showMessage('Laphossz-mdosts!');
      fmGeneralParameter.Visible:=true;
      fmGeneralParameter.leLapHossz.Text:=intToStr(lh);
      fmGeneralParameter.leLaphosszExit(Sender);
    end;//if
    sbAllapotok.Panels.Items[7].Text:=intToStr(lh-(minLapHossz-MinTanszLetsz));
  end
    else
  begin
    mmMuvelet.Enabled:=false;
  end;//if
end;//TfmFoAblak.miMegnyitClick

procedure TfmFoAblak.miSimaClick(Sender: TObject);
begin
  sbAllapotok.Panels.Items[1].Text:=intToStr(lapHossz);
  sbAllapotok.Panels.Items[3].Text:='"Jzansszel" lapozott';
  simaLista(fN);
end;//TfmFoAblak.miSimaClick

procedure TfmFoAblak.miMaskentClick(Sender: TObject);
begin
  sbAllapotok.Panels.Items[1].Text:=intToStr(lapHossz);
  sbAllapotok.Panels.Items[3].Text:='"Msknt" lapozott';
  maskentLista(fN);
end;//TfmFoAblak.miMaskentClick

procedure TfmFoAblak.miTanszekenkentClick(Sender: TObject);
begin
  sbAllapotok.Panels.Items[1].Text:=intToStr(lapHossz);
  sbAllapotok.Panels.Items[3].Text:='Tanszkenknti';
  tanszekenkentLista(fN);
end;//TfmFoAblak.MenuItem1Click

procedure TfmFoAblak.miOsszegfokClick(Sender: TObject);
begin
  sbAllapotok.Panels.Items[1].Text:=intToStr(lapHossz);
  sbAllapotok.Panels.Items[3].Text:='sszegfokozatos';
  osszfokozatosLista(fN);
end;//TfmFoAblak.miOsszegfokClick

procedure TfmFoAblak.miSorokSzamaClick(Sender: TObject);
begin
  fmGeneralParameter.Visible:=true;
  fmGeneralParameter.leLaphossz.SetFocus;
end;//TfmFoAblak.miSorokSzamaClick

procedure TfmFoAblak.miKilepClick(Sender: TObject);
begin
  close;
end;//TfmFoAblak.miKilepClick

//inicializlsok: ------------------------------------------------------------

procedure TfmFoAblak.FormCreate(Sender: TObject);
begin
  minLapHossz:=2{fej-lblc}+4{nyitrekord+zrrekorodOK vagy
               nyit-rekordOK+zrrekord}+MinTanszLetsz{dolgozk min. szma};
  lapHossz:=20;
  mmOutput.Clear; sor:=0; lapSzam:=0;
  sbAllapotok.Panels.Items[1].Text:=intToStr(lapHossz);
  sbAllapotok.Panels.Items[3].Text:='';
  sbAllapotok.Panels.Items[5].Text:='';
  mmMuvelet.Enabled:=false;
end;//TfmFoAblak.FormCreate

procedure TfmFoAblak.FormActivate(Sender: TObject);
(*
  Amikor mr a FoAblak ltrejtt csak azutn lehet a segd ablakkal trdni
*)
begin
  fmGeneralParameter.leLaphossz.EditLabel.Caption:='Laphossz ('+
                                                   intToStr(minLapHossz)+'..'+
                                                   intToStr(MaxLapHossz)+')';
  fmGeneralParameter.leLaphossz.Text:=intToStr(lapHossz);
end;//TfmFoAblak.FormActivate

initialization
  {$I foablak.lrs}

end.
