unit Listazas;
(*
   Minta-unit a sszegfokozatos listzs tmakrhz.

   * A 'SimaListzs': listzs "jzansszel". Kulcspont az 'ElemKi' eljrs
     "laprafrs" figyelse.
   * A 'MskntListzs': listzs a struktramegfeleltets mint elv figyelem-
     bevtelvel.
   * A 'TanszkenkntiListzs': listzs azon felttel mellett, hogy tanszk
     nem trhet meg, vagyis az sszes dolgozja nyitrekorddal egyetemben egy
     lapon kell maradjon. Termszetesen a struktramegfeleltets elv figyelem-
     beveend!
   * Az 'sszegfokozatosListzs': az elbbi olyan tovbbfejlesztse, hogy
     minden egysget (tanszk, kar, egyetem) zruljon egy sszegz rekorddal,
     amelyben a fizetsmez az akkumullt fizetst tartalmazza.
     Tanszkhez vegyk hozz az  sajt lezr rekordjt, rekordjait, st
     a magasabb szint bevezet rekordjait is, azaz ezzel, ezekkel egytt kell
     a lapon maradniuk.
*)

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils; 

  type
    TSzint=(Dolgozo,Tanszek,Kar,Egyetem,Ures);
  const
    KSzint:array [TSzint] of String=(' ','T','K','E','');{kiirand}
    szintKodH=1; nevH=28; cimH=26; telH=9; fizuH=9;      {kirshossz}
    sorHossz=szintKodH+1+nevH+1+cimH+1+telH+1+fizuH;
    MaxLapHossz=100;
    MinTanszLetsz=2;
  var
    minLapHossz,lapHossz:integer;
  type
    TElem=Record
            szintKod:TSzint;
            nev:String[nevH]; cim:String[cimH]; tel:String[telH];
            fiz:LongInt;
          End;
  const
    UresTElem:TElem=(szintKod:Ures;nev:'';cim:'';tel:'';fiz:0);
  type
    TFile=File of TElem;
    TMegnyitasMod=(Letrehozas,Olvasas);

{Import: osszFok.inc}
  procedure general(const fN:string);
  procedure simaLista(const fN:string);
  procedure maskentLista(const fN:string);
  procedure tanszekenkentLista(const fN:string);
  procedure osszfokozatosLista(const fN:string);
  procedure Inic;
  function  maxTanszekMeret(const fN:string):integer;
{Import vge}

  var
    sor:Byte;//a lapra kirt sorok szma
    lapSzam:Byte;//a lapok szma

implementation

uses
  ComCtrls, FoAblak;

  {$i RANDNEV.INC}
  {$i OSSZFOK.INC}

(*---------------------------------------------------------------------------*)

  procedure simaLista(const fN:string);
  (*
    Virtulis tpusok:
    Input:  TBeLap=TFile
            BeNyit,BeVge?,BeOlvas,BeZr
            A reprezentci egyszersge miatt:
            * BeNyit=Megnyitas,
            * BeVge?=Eof,
            * BeOlvas=Read,
            * BeZr=Lezar
    Output: TKiLap="Rekord"(sor:Egsz,kperny:TKperny)
            KiNyit,KiIr,KiZr
            A reprezentci egyszersge miatt:
            * KiNyit=Inic + Lapoz,
            * KiIr=ElemKi (lapozsra gyelve kir),
            * KiZr=lap alja
  *)
  {
    Tpus-reprezentcik:
  }
    Var   elem:TElem;
          f:TFile;
          {lapSzam,sor:Byte; <-- Globlis}
  {
    Tpus-implementcik:
  }
    Procedure KiNyit{output:TKilap};
    Begin
      Inic; Lapoz;
    End;//KiNyit
    Procedure KiZar{output:TKilap};
    Begin
      LapAlja;
    End;//KiZar
  {
    A megolds:
  }
  Begin{simaLista}
    Megnyit(f,fN,Olvasas); KiNyit{output};
    While not Eof(f) do
    Begin
      Read(f,elem);
      ElemKi(elem);
    End;
    Lezar(f); KiZar{output}
  End{simaLista};

(*---------------------------------------------------------------------------*)

  procedure maskentLista(const fN:string);
  (*
    Virtulis tpusok:
    Input:  TBeLap=Rekord(db:Egsz, sorok:Tmb(1..LapHossz:TElem))
            BeNyit,BeVge?,BeOlvas,BeZr
            * BeNyit=Megnyitas,
            * BeVge?=Eof,
            * BeOlvas=puffernyi olvass (res pufferbe),
            * BeZr=Lezar
    Output: TKiLap="Rekord"(sor:Egsz,kperny:TKperny)
            KiNyit,KiIr(belap-puffer!),KiZr
            * KiNyit=Inic
            * KiIr=Lapoz
                 + belap-puffer kirsa
                 + lap alja
            * KiZr=Lezr
  *)
  {
    Tpus-reprezentcik:
  }
    Type TBeLap=Record
                  db:Byte; sorok:Array [1..MaxLapHossz] of TElem;
                End;
    Var   egyLap:TBeLap;
          f:TFile;
          {lapSzam,sor:Byte; <-- Globlis}
  {
    Tpus-implementcik:
  }
    Procedure BeNyit(Var f:TFile);
    Begin
      Megnyit(f,fN,Olvasas);
    End;//BeNyit
    Procedure BeOlvas(Var f:TFile {;Var egyLap:TBeLap});
    Begin
      egyLap.db:=0;
      While Not Eof(f) and (egyLap.db<lapHossz-2{2=fejlc+lblc}) do
      Begin
        Inc(egyLap.db);
        Read(f,egyLap.sorok[egyLap.db]);
      End;
    End;//BeOlvas
    Procedure KiNyit{output:TKilap};
    Begin
      Inic;
    End;//KiNyit
    Procedure KiIr{Var kperny:TKperny, Var egyLap:TBeLap};
      Var i:Integer;
    Begin
      Lapoz;//a fejlc kirsa
      For i:=1 to egyLap.db do
      Begin
        ElemKi(egyLap.sorok[i]); {nem hasznlom ki, hogy
                                  figyeli a sorok szmt}
      End;
      LapAlja;//a lblc kirsa
    End;
    Procedure KiZar{output:TKiLap};
    Begin
      //most semmi fontos
    End;//KiZar
  {
    A megolds:
  }
  Begin{maskentLista}
    BeNyit(f); KiNyit{output};
    While not Eof(f) do
    Begin
      BeOlvas(f{,egyLap});
      KiIr{kperny,egyLap};
    End;
    Lezar(f); KiZar{output}
  End{maskentLista};

(*---------------------------------------------------------------------------*)

  procedure tanszekenkentLista(const fN:string);
  (*
    Virtulis tpusok:
    Input:  bemeneti egysg vagy egy tanszk sszes dolgozja a nyitval
                            vagy valami ms elem
            a bementi eleme hatrt csak elreolvassi technikval
            tudjuk megtallni
            TBeEgyseg=Rekord(db:Egsz,
                             sorok:Tmb(1..MaxTszDolg+1:TElem),
                             e:TElem [az elreolvasott])
            Elfelttel => MaxTszDolg+1=LapHossz
            BeNyit,BeVge?,BeOlvas,BeZr
            * BeNyit=Megnyitas+beLap-puffer inicializls+elreolvass
            * BeVge?=Eof,
            * BeOlvas=egysgolvass elreolvasssal,
            * BeZr=Lezar
    Output: TKiLap="Rekord"(sor:Egsz,kperny:TKperny)
            KiNyit,KiIr(beLap-puffer!),KiZr
            * KiNyit=Inic + Lapoz
            * KiIr=ha nem fr ki => lap alja
                                  + Lapoz
                   beLap-puffer kirsa + sor-llts,
            * KiZr=ha kell, lap alja
  *)
  {
    Tpus-reprezentcik:
  }
    Type TBeEgyseg=Record
                     db:Byte;
                     sorok:Array [1..MaxLapHossz] of TElem;
                     e:TElem;{az elreolvasott}
                   End;
    Var  egyTanszek:TBeEgyseg;
         f:TFile;
         {lapSzam,sor:Byte; <-- Globlis}
  {
    Tpus-implementcik:
  }
    Procedure BeNyit(Var f:TFile);
    {Ef: NOT Eof(f)}
    Begin
      Megnyit(f,fN,Olvasas);
      Read(f,egyTanszek.e);//elreolvass
    End;{BeNyit}
    Procedure BeOlvas(Var f:TFile {;Var egyTanszek:TBeLap});
    {Ef: NOT Eof(f) AND e=elreolvasott elem}
    Begin
      egyTanszek.db:=1; egyTanszek.sorok[1]:=egyTanszek.e;
      Read(f,egyTanszek.e);
      While Not Eof(f) and (egyTanszek.e.szintKod=Dolgozo) do
      Begin
        Inc(egyTanszek.db); egyTanszek.sorok[egyTanszek.db]:=egyTanszek.e;
        Read(f,egyTanszek.e);
      End;
      {Uf: Eof(f)     => egyTanszek[1..egyTanszek.db]+e=egy egysg AND
           NOT Eof(f) => e=kvetkez nem dolgoz elem}
      If Eof(f) then
      Begin
        Inc(egyTanszek.db); egyTanszek.sorok[egyTanszek.db]:=egyTanszek.e;
        egyTanszek.e:=UresTElem;
      End;
      {Uf: egyTanszek[1..egyTanszek.db]=egy egysg AND
           Eof(f)     => e=res AND
           NOT Eof(f) => e=kvetkez nem dolgoz elem}
    End;{BeOlvas}
    Procedure KiNyit{output:TKilap};
    {Ef: a fjlnak legalbb egy eleme van, gy legalbb egy lap kell}
    Begin
      Inic; Lapoz;
    End;//KiNyit
    Procedure KiIr{Var kperny:TKperny, Var egyTanszek:TBeLap};
      Var i:Integer;
    Begin
      If sor+egyTanszek.db+1{lblc}>=LapHossz then//nem fr r az akt. lapra
      Begin
        LapAlja;//a lap "vglegestse", lezrsa
        Lapoz;  //j lap kezdse
      End;
      For i:=1 to egyTanszek.db do
      Begin
        ElemKi({kperny,}egyTanszek.sorok[i]); {nem hasznlom ki, hogy
                                                 figyeli a sorok szmt,
                                                 csak, hogy kirja s a
                                                 sor-t nveli}
      End;
      egyTanszek.db:=0;
    End;{KiIr}
    Procedure KiZar{output:TKiLap};
    Begin
      If sor>0 then LapAlja;
    End;{KiZar}
  {
    A megolds:
  }
  Begin{tanszekenkentLista}
    BeNyit(f); KiNyit{output};
    While not Eof(f) do
    Begin
      BeOlvas(f{,egyTanszek});
      KiIr{kperny,egyTanszek};
    End;
    Lezar(f); KiZar{output};
  end;{tanszekenkentLista}

(*---------------------------------------------------------------------------*)

  procedure osszfokozatosLista(const fN:string);
  (*
    Virtulis tpusok:
    Input:  bemeneti egysg vagy egy tanszk sszes dolgozja a nyitval
                            vagy valami ms elem
            a bementi eleme hatrt csak elreolvassi technikval
            tudjuk megtallni
            TBeEgyseg=Rekord(db:Egsz,
                             elemek:Tmb(1..MaxTszDolg+1:TElem),
                             e:TElem [az elreolvasott])
            Elfelttel => MaxTszDolg+1=LapHossz
            BeNyit,BeVge?,Beolvas,Bezr
            * BeNyit=Megnyitas+beLap-puffer inicializls+elreolvass
            * BeVge?=Eof,
            * BeOlvas=egysgolvass elreolvasssal,
            * BeZr=Lezar
    Output: TKiLap="Rekord"(sor:Egsz,kperny:TKperny),
            KiNyit,KiIr(beLap-puffer!),KiZr
            * KiNyit=Inic + Lapoz,
            * KiIr=ha nem fr ki => lap alja
                                  + Lapoz
                   beLap-puffer kirsa+sor-llts
            * KiZr=ha kell, lap alja
    Megjegyzs:
      Input, Output kzt trtnik a beolvasott "egysg" transzformcija,
      azaz a megfelel szm lezr, sszegz rekord hozzttele
  *)
  {
    Tpus-reprezentcik:
  }
    Type  TBeEgyseg=Record
                      db:Byte;
                      elemek:Array [1..MaxLapHossz] of TElem;
                      e:TElem;{az elreolvasott}
                    End;
    Var   egyTanszek:TBeEgyseg;
          osszFok:Array [TSzint] of TElem;
          f:TFile;
          {lapSzam,sor:Byte; <-- Globlis}
          i,ig:TSzint;
  {
    Tpus-implementcik:
  }
    Procedure BeNyit(Var f:TFile);
    Begin
      Megnyit(f,fN,Olvasas);
      Read(f,egyTanszek.e); //Elreolvass:egyetem
    End;{BeNyit}
    Procedure BeOlvas(Var f:TFile {;Var egyTanszek:TBeLap});
    {Ef: a fjl szintaktikailag helyes AND
         NOT Eof(f) AND e=elreolvasott vmilyen szint nyit elem}
      Var i:TSzint;
    Begin
      egyTanszek.db:=0;
      For i:=egyTanszek.e.szintKod downto Tanszek do
      Begin
        Inc(egyTanszek.db);
        egyTanszek.e.fiz:=0;//nyit elem fizu-ja 0-zand
        egyTanszek.elemek[egyTanszek.db]:=egyTanszek.e;
        osszFok[i]:=egyTanszek.e;
        Read(f,egyTanszek.e);//elreolvass
      End;
      {Uf: egyTanszek.e=elreolvasott dolgoz}
      {egy tanszk beolvassa, elknyvelse:}
      While Not Eof(f) and (egyTanszek.e.szintKod=Dolgozo) do
      Begin
        Inc(egyTanszek.db); egyTanszek.elemek[egyTanszek.db]:=egyTanszek.e;
        Inc(osszFok[Tanszek].fiz,egyTanszek.e.fiz);
        Read(f,egyTanszek.e);
      End;
      {Uf: Eof(f)     => egyTanszek[1..egyTanszek.db]+e=egy egysg AND
           NOT Eof(f) => e=kvetkez nem dolgoz elem}
      If Eof(f) then
      Begin
        Inc(egyTanszek.db); egyTanszek.elemek[egyTanszek.db]:=egyTanszek.e;
        Inc(osszFok[Tanszek].fiz,egyTanszek.e.fiz);
        egyTanszek.e:=UresTElem;
      End;//If Eof
      {Uf: egyTanszek[1..egyTanszek.db]=egy egysg AND
           Eof(f)     => e=resTElem AND
           NOT Eof(f) => e=kvetkez nem dolgoz elem}
    End;{BeOlvas}
    Procedure KiNyit{Var kperny:TKperny};
    Begin
      Inic; Lapoz;
    End;{KiNyit}
    Procedure KiIr{Var kperny:TKperny, Var egyTanszek:TBelap};
      Var i:Integer;
    Begin
      If sor+egyTanszek.db+1{lblc}>LapHossz then
      Begin
        LapAlja; Lapoz;
      End;
      For i:=1 to egyTanszek.db do
      Begin
        ElemKi({kperny,}egyTanszek.elemek[i]); {nem hasznlom ki, hogy
                                                  figyeli a sorok szmt,
                                                  csak, hogy kirja s a
                                                  sor-t nveli}
      End;
    End;{KiIr}
    Procedure KiZar{output:TKiLap};
    Begin
      If sor>0 then LapAlja;
    End;
  {
    A megolds:
  }
  begin{osszfokozatosLista}
    BeNyit(f); KiNyit{kperny};
    {az osszFok-transzformci elksztse:}
    For i:=Dolgozo to Egyetem do osszFok[i]:=UresTElem;
    While not Eof(f) do
    Begin
      {Beolvass:}
      BeOlvas(f{,egyTanszek});
      {"Feldolgozs" = zrrekord(ok) hozzvtele:}
      If Eof(f) then ig:=Egyetem else ig:=egyTanszek.e.szintKod;
      For i:=Tanszek to ig do
      Begin
        Inc(egyTanszek.db);
        egyTanszek.elemek[egyTanszek.db]:=osszFok[i];
        Inc(osszFok[Succ(i)].fiz,osszFok[i].fiz);//sszfokozat gngylts
        osszFok[i]:=UresTElem;
      End;
      {Kirs:}
      Kiir{kperny,egyTanszek};
    End;
    Lezar(f); KiZar{kperny};
  end;//osszfokozatosLista
  
end.
